<!DOCTYPE html>
<html lang="en">
<head>
    <title>task 41.55 Filter Users</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>
    <div class="container">
        <div class="text-center mt-2 mb-2">
          <h2>Danh Sách Đơn Hàng</h2>
        </div>
        <div class="jumbotron container">
          <div class="row form-group">
            <div class="col-sm-5">
             <div class="row form-group">
                <div class="col-sm-4">
                    <label>Trạng thái Order</label>
                </div>
                <div class="col-sm-8">
                    <select id="select-order" class="form-control">
                        <option value="0">All</option>
                        <option value="open">open</option>
                        <option value="confirmed">confirmed</option>
                        <option value="cancel">cancel</option>
                    </select>
                </div>
             </div>
            </div>
            <div class="col-sm-5">
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label>Loại Pizza</label>
                    </div>
                    <div class="col-sm-8">
                        <select id="select-loai-pizza" class="form-control">
                            <option value="0">All</option>
                            <option value="hawaii">hawaii</option>
                            <option value="bacon">bacon</option>
                            <option value="seafood">seafood</option>
                        </select>
                    </div>
                </div>
            </div>
            <div class="col-sm-2">
              <button id="btn-tim-kiem" class="btn btn-success">Tìm kiếm</button>
            </div>
          </div>
      </div>
      
      <div class="container">
        <table class="table table-bordered table-striped table-hover" id="user-table">
          <thead>
            <tr>
              <th>Order ID</th>
              <th>Kích cỡ Combo</th>
              <th>Loại Pizza</th>
              <th>Nước uống</th>
              <th>Thành tiền</th>
              <th>họ và tên</th>
              <th>Số điện thoại</th>
              <th>Trạng thái</th>
              <th>Action</th>
            </tr>
          </thead>
        </table>
      </div>
</body>
<script>
    "use strict";
    $(document).ready(function(){
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        var gDataOrder = [];
        const gNAME_ARRAY_COL = ["orderId", "kichCo",  "loaiPizza",  "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "action"];
        const gCOLUMN_ORDER_ID = 0;
        const gCOLUMN_KICH_CO = 1;
        const gCOLUMN_LOAI_PIZZA = 2;
        const gCOLUMN_DRINK = 3;
        const gCOLUMN_THANH_TIEN = 4 ;
        const gCOLUMN_HO_TEN = 5;
        const gCOLUMN_DIEN_THOAI = 6;
        const gCOLUMN_TRANG_THAI = 7;
        const gCOLUMN_ACTION = 8;
        
     
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    onPageLoading();
    $("#btn-tim-kiem").on("click", function(){
        onBtnTimKiemClick();
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // Hàm load trang
        function onPageLoading(){
            callAPIGetData();
            loadDataToTable();
        }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // hàm call Api get data từ server
        function callAPIGetData(){
              // lấy data từ server
              $.ajax({
                url:  "http://42.115.221.44:8080/devcamp-pizza365/orders",
                type: "GET",
                dataType: 'json',
                success: function(responseObject){
                //debugger;
                gDataOrder = responseObject;
                console.log( gDataOrder);
                displayResulttoTable(gDataOrder);
                },
                error: function(error){
                console.assert(error.responseText);
                }
            });
        };
        // Hàm load dữ liệu
        function loadDataToTable(){

            $("#user-table").DataTable( {
            // Khai báo các cột của datatable
            "columns" : [
                { "data" : gNAME_ARRAY_COL[gCOLUMN_ORDER_ID] },
                { "data" : gNAME_ARRAY_COL[gCOLUMN_KICH_CO] },
                { "data" : gNAME_ARRAY_COL[gCOLUMN_LOAI_PIZZA] },
                { "data" : gNAME_ARRAY_COL[gCOLUMN_DRINK] },
                { "data" : gNAME_ARRAY_COL[gCOLUMN_THANH_TIEN] },
                { "data" : gNAME_ARRAY_COL[gCOLUMN_HO_TEN] },
                { "data" : gNAME_ARRAY_COL[gCOLUMN_DIEN_THOAI] },
                { "data" : gNAME_ARRAY_COL[gCOLUMN_TRANG_THAI] },
                { "data" : gNAME_ARRAY_COL[gCOLUMN_ACTION] },
            ],
            // Ghi đè nội dung của cột action, chuyển thành button chi tiết
            "columnDefs": [ 
            {
                "targets": gCOLUMN_ACTION,
                "defaultContent": "<button class='info-user btn btn-info'>Chi tiết</button>"
            }]
            });
        }
        // hàm hiển thị  dữ liệu vào table
        function displayResulttoTable(paramUser){
            "use strict";
            var vTable = $('#user-table').DataTable();
            vTable.clear();
            vTable.rows.add(paramUser);
            vTable.draw();
        };
        // hàm lọc dữ liệu khi ấn nút tìm kiếm
        function onBtnTimKiemClick(paramFilterDataObj){
            "use strict";
            console.log("nút lọc đã được ấn");
            var vStatus = $("#select-order").val();
            var vPizza = $("#select-loai-pizza").val();
            var vDataFilter = gDataOrder.filter(function(paramOrder, item){
                return (vStatus === "0" || vStatus.toUpperCase() === paramOrder.trangThai.toUpperCase())
                        && (vPizza === "0" || vPizza.toUpperCase() === paramOrder.loaiPizza.toUpperCase())
            })
            // gọi hàm hiển thị kết quả lên bảng
            displayResulttoTable(vDataFilter);
            console.log(vDataFilter);
        }
    })
</script>
</html>